class GroupTaskListController < ApplicationController
   before_action :require_login
   before_action :allowed_pages
   before_action :is_allowed_location
   skip_before_action :verify_authenticity_token,:only=>[:index,:sitesearch]
   include ErpModule::Common
   helper_method :currency_formatted,:year_month_days_formatted,:formatted_date,:set_ent,:set_dct
   helper_method :find_batch_task_detail,:find_batch_task_category
 def index
       @compcodes    = session[:loggedUserCompCode]
       @tseach       = ''
       @LevelHead    = nil
       @batchtask    = MstBatchTaskList.where("bt_compcode = ? ",@compcodes).order("bt_name ASC")
       @batchCateg   = MstBatchTaskCategory.where("btc_compcode = ? ",@compcodes).order("btc_name ASC")
       @batchdetail  = search_group_item
       if params[:id].to_i >0
            @LevelHead  = MstBatchTaskDetail.where("btd_compcode = ? AND id= ?",@compcodes,params[:id].to_i).first
       end
       
end

def create
  @compcodes = session[:loggedUserCompCode]
  isFlags   = true
  begin
  if params[:btd_batchtask] == '' || params[:btd_batchtask]== nil
         flash[:error] =  "Please select batch task"
         isFlags       =  false
  elsif params[:btd_taskcat]=='' || params[:btd_taskcat]== nil
         flash[:error] =  "Please select batch category"
         isFlags       =  false
  elsif params[:btd_description] == '' || params[:btd_description]== nil
         flash[:error] =  "Please enter description."
         isFlags       =  false
   elsif @compcodes == ''  || @compcodes == nil
         flash[:error] =  "Invalid company!"
         isFlags       =  false
   else

          mid          = params[:mid].to_i >0 ? params[:mid] : 0          
          if mid.to_i >0             
              if isFlags
                    objlevel =    MstBatchTaskDetail.where("btd_compcode = ? AND id=?",@compcodes,mid).first
                    if objlevel
                      objlevel.update(levelmaster_params)
                          flash[:error]  =  "Data updated successfully."
                          isFlags        =  true
                    end
              end

          else
              
              if isFlags
                   msterlvelobj = MstBatchTaskDetail.new(levelmaster_params)
                   if msterlvelobj.save
                      flash[:error]  =  "Data saved successfully!"
                      isFlags        =  true
                    end
              end
          end
          session[:request_btd_batchtask] = params[:btd_batchtask]
          session[:request_btd_taskcat]   = params[:btd_taskcat]
   end

  rescue Exception => exc
      flash[:error]            = "#{exc.message}"
      session[:isErrorhandled] = 1
      isFlags                  = false
   end

   if !isFlags
     
     
     session[:isErrorhandled]        = 1
     isFlags                         = false
   else
     session[:request_params]        = nil
     session[:isErrorhandled]        = nil     
     session.delete(:request_params)
   end
    redirect_to "#{root_url}"+"group_task_list"
end


def group_task_list_refresh
 session[:request_params] = nil
 session.delete(:request_params)
 session[:req_groupsrch] = nil
 session[:request_btd_batchtask] = nil
 session[:request_btd_taskcat]   = nil
 redirect_to "#{root_url}"+"group_task_list"
end


def show
   @compcodes  = session[:loggedUserCompCode]
   
end


 def destroy
 customerid     =  params[:id].to_i
 @compcodes     =  session[:loggedUserCompCode]
 @customerId    =  customerid
 #check_customer_group_exist
 #if @isDelFlags
 #      flash[:error] =  "Sorry!! Unable to deletion!"
 #      session[:isErrorhandled] = 1
# else
     leveldelobj =  MstBatchTaskDetail.where("btd_compcode = ? AND id = ? ",@compcodes,customerid).first
     if leveldelobj
        leveldelobj.destroy
        flash[:error]            =  "Data deleted successfully!"
        session[:isErrorhandled] = nil
      end
 #end
  redirect_to "#{root_url}"+"group_task_list"
end


private
def search_group_item
    if params[:page].to_i >0
      pages = params[:page]
    else
       pages = 1
    end
    groupsearch   =  params[:group_search]!='' &&  params[:group_search]!=nil ? params[:group_search] : session[:req_groupsrch]
    iswhere       = "btd_compcode ='#{@compcodes}'"
   if groupsearch!='' &&  groupsearch!=nil
       isgdname       = "%"+groupsearch+"%"
       @tseach        = groupsearch
       session[:req_groupsrch] = groupsearch
       iswhere   += " AND btd_batchtask LIKE '#{isgdname}' OR btd_taskcat LIKE '#{isgdname}'"
   end
   batstaskobj = MstBatchTaskDetail.where(iswhere).paginate(:page =>pages,:per_page => 20).order('btd_nodays ASC')
   return batstaskobj
end

private
def levelmaster_params
  params[:btd_compcode]      = session[:loggedUserCompCode]
  params[:btd_batchtask]     = params[:btd_batchtask]!=nil && params[:btd_batchtask]!='' ? params[:btd_batchtask] : 0
  params[:btd_taskcat]       = params[:btd_taskcat]!=nil && params[:btd_taskcat]!='' ? params[:btd_taskcat] : 0
  params[:btd_nodays]        = params[:btd_nodays]!=nil && params[:btd_nodays]!='' ? params[:btd_nodays] : 0
  params[:btd_description]   = params[:btd_description]!=nil && params[:btd_description]!='' ? params[:btd_description] : ''
  params.permit(:btd_compcode,:btd_batchtask,:btd_taskcat,:btd_nodays,:btd_description)
end

end

