class SitemasterController < ApplicationController
  before_action :require_login
  before_action :allowed_pages
  before_action :is_allowed_location
  skip_before_action :verify_authenticity_token,:only=>[:ajax_process,:sitesearch,:index]
  include ErpModule::Common
  helper_method :formatted_date,:year_month_days_formatted,:get_employee_detail,:get_attached_resp_file
  helper_method :decimal_to_indian_currency,:get_customer_detail
  
  def index
    @compcodes      = session[:loggedUserCompCode]
    cid             = '99'
    @isFlags        = false
    @companyState   = MstInqState.where(["cid = ?", cid])
    @SUser          = MstEmployee.select("id,emp_name,emp_type").where("emp_compcode=?",@compcodes).order("TRIM(emp_name) ASC")
    @LastNo         = get_last_bill_dt
    @AllSNo         = MstSiteMaster.select("st_number,id,st_name").where(["st_compcode = ? AND st_number >0", @compcodes]).order('st_number ASC')
    #@serviceType    = MstServiceType.where("sv_compcode =?",@compcodes).order("sv_name ASC")
    @Groups         =  MstProductBrand.where("pb_compcode=?",@compcodes).order('TRIM(pb_brandname) ASC')
    @catmaster      = MstBatchTaskCategory.where("btc_compcode = ? ",@compcodes).order("btc_name ASC")
    @tseach         = ''
    @topts          = ''
    @Lsite          = nil
    @pId            = nil
    @superviser     = ''
    @security       = ''
    
    if params[:page]!=nil && params[:page].to_i >0
        @pages = params[:page]
     else
        @pages = 1
     end
     
     if params[:id].to_i >0
        @pId    = params[:id].to_i
        @Lsite  = MstSiteMaster.where(["st_compcode = ? AND id=?", @compcodes,params[:id].to_i]).first
        if @Lsite
                spid        = @Lsite.st_supervisior
                secid       = @Lsite.st_security
                if spid
                        isobjemp = get_employee_detail(@compcodes,spid)
                        if isobjemp
                          @superviser = isobjemp.emp_name
                        end
                end
                if secid
                       isobjemps = get_employee_detail(@compcodes,secid)
                       if isobjemps
                         @security = isobjemps.emp_name
                       end
                end
          
        end

     end     
     @mstEmployeeData = search_salesman_list

  end


  def create
  @compcodes = session[:loggedUserCompCode]
  isFlags    = true
  begin
  if params[:st_number]=='' || params[:st_number]==nil
     flash[:error] =  "Please provide site number"
     isFlags = false
   elsif params[:st_name]=='' || params[:st_name]==nil
     flash[:error] =  "Please enter site name"
     isFlags = false 
   elsif @compcodes==''  || @compcodes == nil
     flash[:error] =  "Invalid company!"
     isFlags = false
   else
        myfileid = params[:st_number]!='' && params[:st_number]!=nil ?  params[:st_number] : ''
        mid      = params[:mid].to_i >0 ?  params[:mid] : 0
       if isFlags
            if mid.to_i >0
                 objupdt =   MstSiteMaster.where("st_compcode=? AND id=?",@compcodes,mid).first
                 if objupdt
                    objupdt.update(params_site)
                    deletes_all_files()
                    new_attach_all_files(myfileid)
                    flash[:error]  =  "Data updated successfully."
                    isFlags = true
                 end

            else
              sitename =  params[:st_name]!=nil && params[:st_name]!='' ? params[:st_name].to_s.delete(' ') : ''
              siteobj =  MstSiteMaster.where("st_compcode = ? AND REPLACE(LOWER(st_name),' ','') = ?",@compcodes,sitename)
              if siteobj.length >0
                 isFlags = false
                 flash[:error]  =  "This site is already created."
              end
              if isFlags
                  objmst   = MstSiteMaster.new(params_site)
                  if objmst.save
                     # deletes_all_files()
                      new_attach_all_files(myfileid)
                      get_all_user_send_detail(myfileid)
                      flash[:error]  =  "Data saved successfully."
                      isFlags = true
                  end
              end
           end
       end
   end
   rescue Exception => exc
      flash[:error] =   "#{exc.message}"
      session[:isErrorhandled] = 1
      isFlags = false
   end
     if !isFlags
      session[:request_params] = params
      session[:isErrorhandled] = 1
     else
       session[:request_params] = nil
       session.delete(:request_params)
       session[:isErrorhandled] = nil
     end
     redirect_to "#{root_url}"+"sitemaster"
  end

def sitemaster_refresh   
   session.delete(:request_params)
   session[:request_params]    = nil
   session[:req_sitesearch]    = nil
   session[:req_modsearch]     = nil
   session[:req_sitecodeserch] = nil
   session[:req_salesparams]   = nil
   redirect_to "#{root_url}"+"sitemaster"
end

def show
   @compcodes   = session[:loggedUserCompCode]    
end


def destroy
 customerid     =  params[:id].to_i
 @compcodes     =  session[:loggedUserCompCode]
 @customerId    =  customerid
 @isDelFlags    = false
# check_customer_group_sales
  check_site_linked(customerid)
 if @isDelFlags
       flash[:error]           =  "Sorry!! Unable to deletion! due to somewhere used."
       session[:isErrorhandled] = 1
 else
       @MstDelete   =  MstSiteMaster.where("st_compcode=? AND id=? ",@compcodes,customerid).first
       if @MstDelete
          siteid = @MstDelete.st_number
          @MstDelete.destroy
          allobj = MstSiteMasterAttach.where("sma_compcode=? AND sma_siteno=?",@compcodes,siteid)
          if allobj.length >0
              allobj.each do |ims|
                filex = ims.sma_attachment
                if filex!=nil && filex!=''
                  remove_processs_files(@compcodes,filex)
                end

              end
          end          
          flash[:error] =  "Data deleted successfully."
          session[:isErrorhandled] = nil
        end
  end
  redirect_to "#{root_url}"+"sitemaster"
end



def ajax_process
  if params[:indedntity]!=nil && params[:indedntity]!='' && params[:indedntity]=='USER'
      add_employee_details
      return
  elsif params[:indedntity]!=nil && params[:indedntity]!='' && params[:indedntity]=='SPF'
      get_specification_detail
      return
  elsif params[:indedntity]!=nil && params[:indedntity]!='' && params[:indedntity]=='MATSEL'
      get_material_selected_items
      return
  end


end

private
def get_all_user_send_detail(spe_siteno)
   @logedId             =  session[:autherizedUserId]
   @loginuser           =  @logedId
   @compcodes           = session[:loggedUserCompCode]
   sitename = ''
   if spe_siteno!=nil && spe_siteno!=''
       stitobj  = get_site_names(@compcodes,spe_siteno)
       if stitobj
        sitename = stitobj.st_name
       end
   end

   messages    = " A New Site "+sitename.to_s+" has been created."
   subject     = "NEW SITE CREATED"
   
   userfirst   = 1
   usersecond  = 5
    objuser1 = new_notify_mobiles_email(@compcodes,userfirst)
    objuser2 = new_notify_mobiles_email(@compcodes,usersecond)

      if objuser1
          mobileno1 = objuser1.phonenumber
          email    = nil
          new_po_created_message_mail(mobileno1,messages,subject,email)
       end
      if objuser2
          mobileno2 = objuser2.phonenumber
          email    = nil
          new_po_created_message_mail(mobileno2,messages,subject,email)
       end
   ######## PROCESS EMAIL ###########
    if objuser1
        mobileno1 = nil
        email    = objuser1.email
        new_po_created_message_mail(mobileno1,messages,subject,email)
     end
    if objuser2
        mobileno2 = nil
        email    = objuser2.email
        new_po_created_message_mail(mobileno2,messages,subject,email)
     end
end

private
def search_salesman_list
  nsitesearch    =  params[:sitesearch]!=nil && params[:sitesearch]!='' ? params[:sitesearch] : session[:req_sitesearch]
  nmobilesrch    =  params[:modsearch]!=nil && params[:modsearch]!='' ?  params[:modsearch] : session[:req_modsearch]
  nsitecodeserch =  params[:sitecodeserch]!=nil && params[:sitecodeserch]!='' ?  params[:sitecodeserch] : session[:req_sitecodeserch]
  
  iswhere = " st_compcode='#{@compcodes}'"  
  if nsitesearch!=nil && nsitesearch!=''
      @sitesearch             = nsitesearch
      session[:req_sitesearch] = nsitesearch
      sitesearch  = "%"+@sitesearch.to_s+"%"
      iswhere += " AND st_name LIKE '#{sitesearch}'"
  end
  if nmobilesrch!=nil && nmobilesrch!=''
      @modsearch              = nmobilesrch
      session[:req_modsearch] = nmobilesrch
      modsearch  = "%"+@modsearch.to_s+"%"
      iswhere += " AND st_mobile LIKE '#{modsearch}'"
  end
  if nsitecodeserch!=nil && nsitecodeserch!=''
      @sitecodeserch              = nsitecodeserch
      session[:req_sitecodeserch] = nsitecodeserch
      modsearch       = "%"+@sitecodeserch.to_s+"%"
      iswhere += " AND st_number LIKE '#{modsearch}'"
  end
 items  =  MstSiteMaster.where(iswhere).paginate(:page =>@pages,:per_page => 25).order('st_number ASC')
return items
end


private
def get_last_bill_dt
  @xLoc       = (session[:autherizedLoc].to_i >0) ? session[:autherizedLoc] : 0
  @isCode     = 0
  @Startx    = '0000'
  @recCodes  = MstSiteMaster.select("st_number").where(["st_compcode = ? AND st_number >0", @compcodes]).order('st_number DESC').first
   if @recCodes
    @isCode    = @recCodes.st_number.to_i
   end

    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_i < 10
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >5
      @sumXOfCode =  @sumXOfCode.to_i
    end
    return @sumXOfCode
end



private
def params_site
  @compcodes  =  session[:loggedUserCompCode]
  @Startx     = '0000'
   if @compcodes!=nil || @compcodes!= ''
        @recCodes = MstSiteMaster.select("st_number").where(["st_compcode = ? AND st_number >0", @compcodes]).order('st_number DESC').first
        if @recCodes
         @isCode    = @recCodes.st_number.to_i
        end
   end
    @sumOfCode    = @isCode.to_i + 1
    if @sumOfCode.to_i < 10
      @sumOfCode = p @Startx.to_s + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 3
      @sumOfCode = p "000" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 4
      @sumOfCode = p "00" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 5
      @sumOfCode = p "0" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length >5
      @sumOfCode =  @sumOfCode.to_i
    end
    if params[:mid].to_i >0
      params[:st_number]      =  params[:st_number]
    else
      params[:st_number]      = @sumOfCode
    end  
  params[:st_name]        = params[:st_name]!=nil && params[:st_name]!='' ? params[:st_name].to_s.strip : ''
  params[:st_supervisior] = params[:st_supervisior]!=nil && params[:st_supervisior]!='' ? params[:st_supervisior] : 0
  params[:st_security]    = params[:st_security]!=nil && params[:st_security]!='' ? params[:st_security] : 0
  params[:st_address]     = params[:st_address]!=nil && params[:st_address]!='' ? params[:st_address].to_s.strip : ''
  params[:st_mobile]      = params[:st_mobile]!=nil && params[:st_mobile]!='' ? params[:st_mobile].to_s.strip : ''
  params[:st_estm_cost]   = params[:st_estm_cost]!=nil && params[:st_estm_cost]!='' ? params[:st_estm_cost] : 0
  params[:st_size]        = params[:st_size]!=nil && params[:st_size]!='' ? params[:st_size] : ''
  @loginuser                   = session[:autherizedUserId]
  params[:st_authorize_user]   = @loginuser
  stdt   = 0
  trdate = 0
  if params[:st_start_date]!=nil && params[:st_start_date]!=''
     stdt =  year_month_days_formatted(params[:st_start_date])
  end
  if params[:st_target_date]!=nil && params[:st_target_date]!=''
     trdate =  year_month_days_formatted(params[:st_target_date])
  end
  contracts = ''
  if params[:listcontractor]!=nil && params[:listcontractor]!=nil
    params[:listcontractor].each do |itms|
      contracts +=itms.to_s+","
    end
    if contracts!=nil && contracts!=''
      contracts = contracts.chop
    end
  end
  category = ""
  if params[:assigncat]!=nil && params[:assigncat]!= ''
       params[:assigncat].each do |catitems|
        category += catitems.to_s+","
      end
      if category !=nil && category !=''
        category = category.to_s.chop
      end
  end
  params[:st_category]       = category
  params[:st_contractno]   = contracts
  params[:st_start_date]   = stdt
  params[:st_target_date]  = trdate
  params[:st_compcode]     = @compcodes
  params.permit(:st_compcode,:st_category,:st_contractno,:st_size,:st_authorize_user,:st_number,:st_name,:st_supervisior,:st_security,:st_address,:st_mobile,:st_start_date,:st_target_date,:st_estm_cost,:st_completed)

end



private
def add_employee_details
    compcodes  = session[:loggedUserCompCode]
    sitename   = params[:sitename]!=nil && params[:sitename]!='' ? params[:sitename] : ''
    userxtypes = params[:userxtypes]!=nil && params[:userxtypes]!='' ? params[:userxtypes] : ''
    users      = 0
    if userxtypes =='SR'
      users =8
    elsif userxtypes =='ST'
      users =9
    end
    message = ''
    isflags = false
    params[:emp_type]     = users
    params[:emp_name]     = sitename
    params[:emp_compcode] = compcodes
    siteemp = MstEmployee.new(site_user_params)
    if siteemp.save
      message = "Data saved successfully."
      isflags = true
    end
    
    myitems = MstEmployee.select("id,emp_name").where("emp_compcode=? AND emp_type=?",compcodes,users).order("TRIM(emp_name) ASC")
     respond_to do |format|
       format.json { render :json => { 'depdata'=>myitems, "isstatus"=>isflags,"message"=>message } }
     end
     
end

private
def get_specification_detail
    compcodes  = session[:loggedUserCompCode]
    myitems    = MstLevelMaster.select("id,lm_levelcode,lm_specification,lm_description").where("lm_compcode =? AND lm_specification<>''",compcodes).order("TRIM(lm_levelcode) ASC")
    message    = ''
    if myitems.length >0
      isflags = true
      message = 'Success'
    end
    respond_to do |format|
     format.json { render :json => { 'levdata'=>myitems, "isstatus"=>isflags,"message"=>message } }
    end
end

private
def site_user_params
  params[:emp_email] = ''
  params[:emp_mobile] = ''
  params[:emp_pano] = ''
  params[:emp_adhar_no] = ''
  params[:emp_address] = ''
  params[:emp_department] = 0
  params[:emp_designation] = 0
  params[:emp_qualification] = 0
  params[:emp_pin_no]        = ''
  params[:emp_state_code]    = 0
  params.permit(:emp_compcode,:emp_name,:emp_email,:emp_mobile,:emp_pano,:emp_adhar_no,:emp_type,:emp_address,:emp_department,:emp_designation,:emp_qualification,:emp_pin_no,:emp_state_code)
end

private
def process_enquiry_files(compcodes,files,docid,fileid,cfl_title)
      if  fileid!=nil && fileid!='' && files!=nil && files!=''
             selobj = MstSiteMasterAttach.where("sma_compcode=? AND id=?",compcodes,docid).first
              if selobj
                  selobj.update(:sma_attachment=>files,:sma_title=>cfl_title)
              else
                  objenq = MstSiteMasterAttach.new(:sma_compcode=>compcodes,:sma_siteno=>fileid,:sma_attachment=>files,:sma_title=>cfl_title)
                  if objenq.save
                    ## execute message
                  end
              end
      end
end


private
def new_attach_all_files(fileid)

     if params[:processedit]!=nil && params[:processedit]!=''
         i = 0
         k = 1

            params[:processedit].each do |fil|
                if  params["myreceivedocumentid#{i}"].to_i >0
                       recvdocuments = params["myreceivedocumentid#{i}"]
                       cftitle       = params["cfl_title#{i}"]
                       currentfile   = params["existfile#{i}"]
                       nremove       = params["removefiles#{i}"]
                       if params["receivefile#{i}"]!=nil && params["receivefile#{i}"]!=''
                             filename      =  params["receivefile#{i}"]
                             filex         =  new_attach_files(filename,k)
                             process_enquiry_files(@compcodes,filex,recvdocuments,fileid,cftitle)
                       else
                            if currentfile!=nil && currentfile!=''
                                filex         = currentfile
                                if nremove.to_i <=0
                                  process_enquiry_files(@compcodes,filex,recvdocuments,fileid,cftitle)
                                end
                            end
                       end
                end

                 i +=1
                 k +=1
           end
     end
     if params[:receivefile]!=nil && params[:receivefile]!=''
           m = 0
           c = 1
           
            params[:receivefile].each do |fil|
                if  params[:myreceivedocumentid][m].to_i <=0
                      recvdocuments = params[:myreceivedocumentid][m]
                      cftitle       = params[:cfl_title][m]
                       if params[:receivefile][m]!=nil && params[:receivefile][m]!=''
                             filename      =  params[:receivefile][m]
                            
                             filex         =  new_attach_files(filename,c)
                            
                             process_enquiry_files(@compcodes,filex,recvdocuments,fileid,cftitle)
                       end
                end
                 m +=1
                 c +=1
           end
     end

end

private
def deletes_all_files
   compcodes    = session[:loggedUserCompCode]
  i =0
  if params[:processedit]!=nil && params[:processedit]!=''
       params[:processedit].each do |fls|
          if  params["removefiles#{i}"]!=nil &&  params["removefiles#{i}"]!=''
            remove_processs_files(compcodes,params["removefiles#{i}"])
          end
          i +=1
       end
  end
end

private
def remove_processs_files(compcodes,docid)
  selobj = MstSiteMasterAttach.where("sma_compcode=? AND id=?",compcodes,docid).first
  if selobj
    filname      = selobj.sma_attachment
    path_to_file = Rails.root.join "public", "images", "siteattach",filname
    unlinks_the_files(path_to_file)
    selobj.destroy
  end
end

private
  def unlinks_the_files(path_to_file)
    File.delete(path_to_file) if File.exist?(path_to_file)
  end

private
  def new_attach_files(files,cnt)
    file_name     =  files.original_filename  if  ( files !='')
    file          =  files.read
    file_type     =  file_name.split('.').last
    new_name_file = Time.now.to_i+cnt.to_i
    new_file_name = "#{new_name_file}." + file_type
    @Imgs         = new_file_name
    @paths        = Rails.root.join "public", "images", "siteattach"
    ######### Upload here ######################
    File.open("#{@paths}/" +new_file_name, "wb")  do |f|
      f.write(file)
    end
    return new_file_name
  end

private
 def check_site_linked(sitid)
   issiteobj   = MstSiteMaster.select("st_number").where("st_compcode=? AND id=?",@compcodes,sitid).first
   siteno      = ''
   if issiteobj
      siteno = issiteobj.st_number
   end
   sitkinkobj = MstSiteLinking.where("stl_compcode = ? AND stl_siteno = ?",@compcodes,siteno)
   if sitkinkobj.length >0
      @isDelFlags =true
   end
    @delPoobj = TrnBatchTaskAssign.where("bts_compcode = ? AND bts_siteno = ?",@compcodes,siteno)
    if @delPoobj.length >0
        @isDelFlags = true
    end   
  
 end

 private
def get_material_selected_items
    compcodes  = session[:loggedUserCompCode]
    mattype    = params[:mattype] ? params[:mattype].to_s.strip : ''
    srch       = params[:search_name] ? params[:search_name].to_s.strip : ''
    iswhere    = nil
    myitems    = nil
    isselect   = ""
    isorder    = ""
    isgroups   = ""
    if mattype!=nil && mattype!='' && mattype =='M'
      iswhere = "pd_compcode='#{compcodes}' AND pd_sel_material LIKE '#{srch}%'"
      isselect = "pd_sel_material"
      isorder  = "pd_sel_material"
      isgroups  = "pd_sel_material"
    elsif mattype!=nil && mattype!='' && mattype =='B'
      iswhere = "pd_compcode='#{compcodes}' AND pd_sel_brand LIKE '%#{srch}%'"
      isselect = "pd_sel_brand"
      isorder  = "pd_sel_brand"
      isgroups  = "pd_sel_brand"
    elsif mattype!=nil && mattype!='' && mattype =='MD'
      iswhere = "pd_compcode='#{compcodes}' AND pd_sel_model LIKE '%#{srch}%'"
      isselect = "pd_sel_model"
      isorder  = "pd_sel_model"
      isgroups = "pd_sel_model"
    elsif mattype!=nil && mattype!='' && mattype =='T'
      iswhere = "pd_compcode='#{compcodes}' AND pd_sel_thickness LIKE '%#{srch}%'"
      isselect = "pd_sel_thickness"
      isorder  = "pd_sel_thickness"
      isgroups = "pd_sel_thickness"
   elsif mattype!=nil && mattype!='' && mattype =='S'
      iswhere = "pd_compcode='#{compcodes}' AND pd_sel_size LIKE '%#{srch}%'"
      isselect = "pd_sel_size"
      isorder  = "pd_sel_size"
      isgroups = "pd_sel_size"
   elsif mattype!=nil && mattype!='' && mattype =='C'
      iswhere = "pd_compcode='#{compcodes}' AND pd_sel_color LIKE '%#{srch}%'"
      isselect = "pd_sel_color"
      isorder  = "pd_sel_color"
      isgroups = "pd_sel_color"
    end    
    if iswhere!=nil && srch!=''
      myitems = MstProduct.select(isselect).where(iswhere).group(isgroups).order(isorder).limit("20")
    end    
    message    = ''
    if  myitems!=nil && myitems.length >0
      isflags = true
      message = 'Success'
    end
    respond_to do |format|
     format.json { render :json => { 'levdata'=>myitems, "isstatus"=>isflags,"message"=>message } }
    end
end
end ### End class
