class SuperAdminController < ApplicationController
  before_action :require_login
  before_action :allowed_pages
  before_action :is_allowed_location
  skip_before_action :verify_authenticity_token,:only=>[:ajax_process,:sitesearch,:index]
  include ErpModule::Common
  helper_method :formatted_date,:year_month_days_formatted
  helper_method :decimal_to_indian_currency,:get_customer_detail,:get_users_listed
  
  def index
    @compcodes      = session[:loggedUserCompCode]
    cid             = '99'
    @isFlags        = false
    @listCompDtl    = nil
    @registerComp   = get_last_companyno
     sitesearch     = params[:sitesearch]!=nil && params[:sitesearch]!='' ? params[:sitesearch] : ''
     modsearch      = params[:modsearch]!=nil && params[:modsearch]!='' ? params[:modsearch] : ''
     sitecodeserch  = params[:sitecodeserch]!=nil && params[:sitecodeserch]!='' ? params[:sitecodeserch] : ''
     iswhere        = "cmp_companycode<>''"
     
     if sitesearch !=nil && sitesearch !=''
       iswhere    += " AND cmp_companyname LIKE '%#{sitesearch}%'"
       @sitesearch = sitesearch
     end
     if modsearch !=nil && modsearch !=''
       iswhere    += " AND cmp_cell_number LIKE '%#{modsearch}%'"
       @modsearch = modsearch
     end
     if sitecodeserch !=nil && sitecodeserch !=''
       iswhere    += " AND email LIKE '%#{sitecodeserch}%'"
       @sitecodeserch = sitecodeserch
     end

      @compList       = MstCompany.where(iswhere).order("cmp_companyname ASC")
      if params[:id].to_i >0
      @listCompDtl = MstCompany.where("id = ?",params[:id]).first
      end

  end


  def create
  
  isFlags    = true
  begin
  if params[:cmp_companycode] == '' || params[:cmp_companycode] == nil
     flash[:error] =  "Please enter company code"
     isFlags = false
   elsif params[:cmp_companyname]=='' || params[:cmp_companyname]==nil
     flash[:error] =  "Please enter company name"
     isFlags       = false
   else
        curruser  = params[:curuser]!='' && params[:curuser]!=nil ?  params[:curuser].to_s.delete(' ') : ''
        compcodes = params[:cmp_companycode]!='' && params[:cmp_companycode]!=nil ?  params[:cmp_companycode].to_s.delete(' ') : ''
        username  = params[:admin_user]!= nil && params[:admin_user] !='' ? params[:admin_user].to_s.strip : ''
        mobileno  = params[:mobileno]!= nil && params[:mobileno] !='' ? params[:mobileno].to_s.strip : ''
        curmobile = params[:currmobileno]!= nil && params[:currmobileno] !='' ? params[:currmobileno].to_s.strip : ''
        if curruser != username
          userobj   = User.where("username = ?",username)
           if userobj.length >0
              flash[:error]  =  "This user is already exists's,Please try another."
              isFlags = false
           end
        end
        if isFlags
            if mobileno != curmobile
                userobj   = User.where("phonenumber = ?",mobileno)
                if userobj.length >0
                  flash[:error]  =  "This mobile no is already exists's,Please try another."
                  isFlags = false
                end
            end
        end

        if isFlags
           comobj =   MstCompany.where("cmp_companycode =? ",compcodes)
            if comobj.length >0
                 objupdt =   MstCompany.where("cmp_companycode =? ",compcodes).first
                 if objupdt
                   objupdt.update(company_params)
                   #create_user_detail()
                    flash[:error]  =  "Data updated successfully."
                    isFlags = true
                 end

            else
              
              mstobj  =  MstCompany.where("cmp_companycode = ?",compcodes)
              if mstobj.length >0
                 isFlags = false
                 flash[:error]  =  "This company is already created."
              end
                  if isFlags
                      objmst   = MstCompany.new(company_params)
                      if objmst.save
                          params[:compcodes] = @sumXOfCode
                          create_user_detail()
                          flash[:error]  =  "Data saved successfully."
                          isFlags = true
                      end
                  end
           end
       end
   end
   rescue Exception => exc
      flash[:error] =   "#{exc.message}"
      session[:isErrorhandled] = 1
      isFlags = false
   end
     if !isFlags
        session[:request_params] = params
        session[:isErrorhandled] = 1
     else
         session[:request_params] = nil
         session.delete(:request_params)
         session[:isErrorhandled] = nil
     end
     redirect_to "#{root_url}"+"super_admin"
  end

def super_admin_refresh
     session.delete(:request_params)
     session[:request_params]    = nil
     session[:req_sitesearch]    = nil
     session[:req_modsearch]     = nil
     session[:req_sitecodeserch] = nil
     session[:req_salesparams]   = nil
     redirect_to "#{root_url}"+"super_admin"
end

def show
   @compcodes   = session[:loggedUserCompCode]    
end


def destroy
 customerid     =  params[:id].to_i
 @compcodes     =  session[:loggedUserCompCode]
 @customerId    =  customerid
 isFlags        =  true
 mstobj         =  MstCompany.where("id = ?",customerid).first
 if mstobj
     compcodes = mstobj.cmp_companycode
     userobj   = User.where("usercompcode=?",compcodes)
     if userobj.length >0
          flash[:error]  = "This company could not be deleted due to used in user."
          isFlags        = false
     end
     if isFlags
        mstobj.destroy
        flash[:error]  =  "Data deleted sucessfully."
        isFlags        =  true
     end
     
 end
  redirect_to "#{root_url}"+"super_admin"
end



def ajax_process
  if params[:indedntity]!=nil && params[:indedntity]!='' && params[:indedntity]=='USER'
      add_employee_details
      return
  
  end


end

private
def check_user_already
  
end

private
def company_params
    @isCode     = 0
    @Startx     = '1000'
    @recCodes   = MstCompany.select("cmp_companycode").where(["cmp_companycode <>'' "]).last
    if @recCodes
    @isCode    = @recCodes.cmp_companycode.to_i
    end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_s.length < 2
    @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
    @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
    @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
    @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >=5
    @sumXOfCode =  @sumXOfCode.to_i
    end
  if params[:mid].to_i >0
    params[:cmp_companycode] = params[:cmp_companycode]
  else
    params[:cmp_companycode] = @sumXOfCode
  end
  params[:cmp_companyname]      = params[:cmp_companyname]!='' && params[:cmp_companyname]!=nil ? params[:cmp_companyname] : ''
  params[:cmp_typeofbussiness]  = ''
  params[:cmp_compidentity_no]  = ''
  params[:cmp_addressline3]     = ''
  params[:cmp_telephonenumber]  = '0'
  params[:cmp_gstname]          = '0'
  params[:cmp_pannumber]        = ''
  params[:cmp_adharnumber]      = ''
  params[:cmp_termandcondition] = ''
  params[:cmp_otp]              = ''
  params[:cmp_declaration]      = ''
  params[:cmp_logos]            = ''
  params[:cmp_signs]            = ''
  params[:cmp_show_logo]        = 'N'
  params[:cmp_show_pay_pop]     = 'N'
  session[:authorizedGSTNumber] = nil
  params[:cmp_cell_number]      = params[:cmp_cell_number]!=nil && params[:cmp_cell_number]!='' ? params[:cmp_cell_number].to_s.delete(' ') : ''
  params[:cmp_email]            = params[:cmp_email]!=nil && params[:cmp_email]!='' ? params[:cmp_email].to_s.strip.downcase : ''

   params[:comp_ad_code]         = ''
   params[:comp_use_code]        = ''
   params[:cmp_show_unbilled]    = 'N'
   params[:cmp_credit_debit_sgn] = 'N'
   params[:cmp_proddup_allowed]  = 'N'
   params[:cmp_raw_material]     = 'N'
   params[:cmp_multi_loc]        = 'N'
   params[:cmp_status]           = 'Y'
   params[:cmp_godam_allowed]    = 'N'
   params[:cmp_negative_stock]   = 'N'
   params[:cmp_unitname]         = ''
   params[:cmp_gst_registered]   = 'N'
   params[:cmp_tradename]        = ""
   params[:cmp_addressline1]     = ""
   params[:cmp_addressline2]     = ""
   params[:cmp_bankname]         = ""
   params[:cmp_bankbranch]       = ""
   params[:cmp_accountnumber]    = ""
   params[:cmp_nof_user]         = params[:admin_total_user] !=nil && params[:admin_total_user] !='' ? params[:admin_total_user] : 0
   params[:cmp_validity]         = params[:admin_validateupto] !=nil && params[:admin_validateupto] !='' ? year_month_days_formatted(params[:admin_validateupto]) : 0
   if params[:mid].to_i >0
     params.permit(:cmp_nof_user,:cmp_validity,:cmp_companyname,:comp_ad_code,:comp_use_code,:cmp_corresp_cont_name,:cmp_corresp_address1,:cmp_corresp_address2,:cmp_corresp_address3,:cmp_corresp_telephone,:cmp_corresp_mobile,:cmp_corresp_email,:cmp_corresp_country,:cmp_corresp_state,:cmp_cont_name,:cmp_tradename,:cmp_gstname,:cmp_typeofbussiness,:cmp_addressline1,:cmp_telephonenumber,:cmp_addressline2,:cmp_cell_number,:cmp_addressline3,:cmp_stateandcode,:cmp_email,:cmp_bankname,:cmp_bankbranch,:cmp_accountnumber,:cmp_bankifsccode,:cmp_countrycode,:cmp_pannumber,:cmp_adharnumber,:cmp_termandcondition,:cmp_declaration,:cmp_logos,:cmp_compidentity_no,:cmp_otp,:cmp_signs,:cmp_show_logo,:cmp_show_pay_pop,:cmp_credit_debit_sgn,:cmp_proddup_allowed,:cmp_raw_material,:cmp_multi_loc,:cmp_status,:cmp_unitname,:cmp_gst_registered,:cmp_godam_allowed,:cmp_negative_stock,:cmp_show_unbilled)
   else
     params.permit(:cmp_companycode,:cmp_nof_user,:cmp_validity,:cmp_companyname,:comp_ad_code,:comp_use_code,:cmp_corresp_cont_name,:cmp_corresp_address1,:cmp_corresp_address2,:cmp_corresp_address3,:cmp_corresp_telephone,:cmp_corresp_mobile,:cmp_corresp_email,:cmp_corresp_country,:cmp_corresp_state,:cmp_cont_name,:cmp_tradename,:cmp_gstname,:cmp_typeofbussiness,:cmp_addressline1,:cmp_telephonenumber,:cmp_addressline2,:cmp_cell_number,:cmp_addressline3,:cmp_stateandcode,:cmp_email,:cmp_bankname,:cmp_bankbranch,:cmp_accountnumber,:cmp_bankifsccode,:cmp_countrycode,:cmp_pannumber,:cmp_adharnumber,:cmp_termandcondition,:cmp_declaration,:cmp_logos,:cmp_compidentity_no,:cmp_otp,:cmp_signs,:cmp_show_logo,:cmp_show_pay_pop,:cmp_credit_debit_sgn,:cmp_proddup_allowed,:cmp_raw_material,:cmp_multi_loc,:cmp_status,:cmp_unitname,:cmp_gst_registered,:cmp_godam_allowed,:cmp_negative_stock,:cmp_show_unbilled)
   end


end

private
def create_user_detail
    userobj = User.new(user_params)
    if userobj.save
      ## execute message if required
    end
end

private
def user_params
    compcode       = params[:compcodes]
    company        = ''
    master         = ''
    transaction    = ''
    report         = ''
    specialper     = ''
    sitepermission = ''
    if params[:admin_password] != '' && params[:admin_password] != nil
       xpassword = Digest::MD5.hexdigest(params[:admin_password])
    end
   params[:cmp_logos]       = ''   
   params[:userimage]       = ''
   params[:email]           = params[:cmp_email]
   params[:phonenumber]     = params[:cmp_cell_number] 
   params[:userpassword]    = xpassword
   params[:usercompcode]    = compcode
   params[:userpermission]  = ''
   params[:spspermission]   = ''
   params[:company]         =  company
   params[:master]          =  master
   params[:mytransaction]   =  transaction
   params[:report]          =  report
   params[:specialpermit]   =  specialper
   params[:sitepermission]  =  sitepermission
   params[:username]        =  params[:admin_user]
   params[:product_prefix]  =  ''
   params[:product_length]  =  0
   params[:emp_id]          =  0
   params[:firstname]       =  params[:admin_user]
   params.permit(:usercompcode,:emp_id,:sitepermission,:company,:master,:mytransaction,:report,:username,:userpassword,:firstname,:lastname,:email,:phonenumber,:usertype,:userpermission,:userlocation,:spspermission,:product_prefix,:product_length,:userimage,:specialpermit)

 end

private
def get_last_companyno
  
    @isCode     = 0
    @Startx     = '1000'
    @recCodes   = MstCompany.select("cmp_companycode").where(["cmp_companycode <>''"]).last
    if @recCodes
    @isCode    = @recCodes.cmp_companycode.to_i
    end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_s.length < 2
    @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
    @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
    @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
    @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >=5
    @sumXOfCode =  @sumXOfCode.to_i
    end
end

private
def get_users_listed(id)
  userobj   = User.where("id = ?",id).first
  return userobj
end

end ### End class
