class TaskListController < ApplicationController
  before_action :require_login
  before_action :allowed_pages
  before_action :is_allowed_location
  skip_before_action :verify_authenticity_token,:only=> [:index,:ajax_process] 
  include ErpModule::Common
  helper_method :get_all_assigned_task_listed,:get_employee_detail,:get_selected_user_detail,:currency_formatted,:formatted_date,:year_month_days_formatted
  helper_method :get_total_conversation,:all_category_assigned_intask,:get_sitewise_pending_task,:taskwise_chat_assign_user_notify,:get_task_signle_listed
def index
  @compcodes       = session[:loggedUserCompCode]
  loguserid        = session[:autherizedUserId]
  @listItem        = nil
  @mstXEmpEdit     = User.where("usercompcode = ?",@compcodes).order("firstname ASC")
  @userList        = User.where("usercompcode = ? and id = ?",@compcodes,loguserid).first
  @batchCateg      = MstBatchTaskCategory.where("btc_compcode = ? ",@compcodes).order("btc_name ASC")
  @AllSNo          = MstSiteMaster.select("st_number,id,st_name").where(["st_compcode = ? AND st_number >0", @compcodes]).order('st_number ASC')
  @TodayNps        = get_all_notification("TDY");
  @UnreadNp        = get_all_notification("UNR");
  @NextSevNps      = get_all_notification("NXTSEVDS");
  @AssignTaskTot   = all_count_task_byassigner(loguserid)
  @SitewiseNps     = sitewise_notification(loguserid)
  @cDated          = formatted_date(Time.now.to_date)
  @curdated        = Time.now.to_date
  #@ListAllCategory = all_category_assigned_intask
  @ListAllsite     = all_sitewise_task_listing()
end

def create
  @compcodes  = session[:loggedUserCompCode]
 
end

def destroy
 customerid     =  params[:id].to_i
 @compcodes     =  session[:loggedUserCompCode]  
  redirect_to "#{root_url}"+"task_list"
end

def task_list_refresh
   session[:request_params] = nil
   session.delete(:request_params)
   redirect_to "#{root_url}"+"task_list"
end





private
def get_rake_wise_printable
  pdcode                   = params[:prod_code]!=nil && params[:prod_code]!='' ? params[:prod_code] : ''
  session[:prod_rake_code] = nil
  newobj   = TrnProductRakeLinking.select("prl_compcode,prl_rakeno,prl_qnty,prl_prodcode,'' as prodname").where("prl_compcode=? AND prl_prodcode=?",@compcodes,pdcode)
  isstatus = false
  ispath   = ''
  if newobj.length >0    
      isstatus = true
      session[:prod_rake_code] = pdcode
      printcontroll  = "1_printing_report"
      ispath         =  printing_path(printcontroll,:format=>"pdf")
  end
   respond_to do |format|
     format.json { render :json => { 'data'=>'',:status=>isstatus,'path'=>ispath } }
   end

end

private
def get_all_notification(type)
     posteduserid     = params[:assigneduserto]
    loguserid        = session[:autherizedUserId]
    mycounts  = 0
     iswhere   = "bts_compcode = '#{@compcodes}' AND ( bts_assignby ='#{loguserid}' OR FIND_IN_SET('#{loguserid}',bts_multiassign)>0 )"
    
    if type == 'TDY'
      iswhere  += " AND DATE(bts_assigndate) = DATE(NOW()) AND bts_readstatus ='N' "
    elsif type == 'UNR'
      iswhere  += " AND bts_readstatus ='N'"
    elsif type == 'NXTSEVDS'
      iswhere  += " AND bts_assigndate BETWEEN CURDATE() AND DATE_ADD(CURDATE(),INTERVAL 7 DAY) AND bts_readstatus ='N'"
    end
    isselect  = "COUNT(*) as totals"    
    assignobj = TrnBatchTaskAssign.select(isselect).where(iswhere).first
    if assignobj
      mycounts = assignobj.totals
    end
    return mycounts
end

private
def all_count_task_byassigner(loguserid)
    mycounts  = 0
   iswhere    = "bts_compcode = '#{@compcodes}' AND ( FIND_IN_SET('#{loguserid}',bts_multiassign)>0 OR bts_assignby='#{loguserid}')"
   isselect   = "COUNT(*) as totals"   
    assignobj = TrnBatchTaskAssign.select(isselect).where(iswhere).first
    if assignobj
      mycounts = assignobj.totals
    end
   return mycounts
end

private
def sitewise_notification(loguserid)  
   iswhere    = "bts_compcode = '#{@compcodes}' AND ( FIND_IN_SET('#{loguserid}',bts_multiassign)>0 OR bts_assignby='#{loguserid}' ) AND bts_readstatus ='N'"
   isselect   = "COUNT(*) as totals,st_name as sitename,bts_siteno as sitenumber"
   jonx       = " LEFT JOIN mst_site_masters st ON(st_compcode = bts_compcode AND st_number = bts_siteno)"
   assignobj  = TrnBatchTaskAssign.select(isselect).joins(jonx).where(iswhere).group("bts_siteno")
   return assignobj
end

private
def get_all_assigned_task_listed(catid,siteno)
   posteduserid     = params[:assigneduserto].to_i >0 ? params[:assigneduserto] :  session[:assigneduserto]
   loguserid        = session[:autherizedUserId]
   assigntaskstatus = params[:assigntaskstatus] !=nil && params[:assigntaskstatus] !='' ? params[:assigntaskstatus] : session[:assigntaskstatus]
   processtask      = params[:processtask]
   inclause        = ""
   listclause      = ""
   if posteduserid.to_i >0
     
      iswhere    = "bts_compcode = '#{@compcodes}' AND bts_siteno ='#{siteno}' AND ( bts_assignby ='#{loguserid}'  AND  FIND_IN_SET('#{posteduserid}',bts_multiassign)>0 )"
   else
     
      iswhere    = "bts_compcode = '#{@compcodes}' AND bts_siteno ='#{siteno}' AND ( bts_assignby ='#{loguserid}'  OR  FIND_IN_SET('#{loguserid}',bts_multiassign)>0 )"
   end
   
   if catid.to_i >0
      iswhere += " AND bts_taskcat = '#{catid}'"
   end
   if processtask == 'TD'
      iswhere  += " AND DATE(bts_assigndate) = DATE(NOW()) "
    elsif processtask == 'PD'
      iswhere  += " AND bts_readstatus ='N' "
    elsif processtask == 'SD'
      iswhere  += " AND bts_assigndate BETWEEN CURDATE() AND DATE_ADD(CURDATE(),INTERVAL 7 DAY) "   
    end
     if processtask == nil ||  processtask == ''
         if assigntaskstatus !=nil && assigntaskstatus !=''
               assigntaskstatus.each do |gtask|
                 inclause   += "'"+gtask.to_s+"',"
                 listclause += gtask.to_s+","
               end
               if inclause !=nil && inclause !=''
                 inclause = inclause.to_s.chop
               end
               if inclause.to_s.length == 1
                     clauses = inclause.to_s.delete("'")
                      if clauses.to_s =='all'
                        ## view all item list
                      else
                         iswhere += " AND bts_readstatus IN(#{inclause})"
                      end
               else
                     clauses = inclause.to_s.delete("'")
                      if clauses.to_s =='all'
                        ## view all item list
                      else
                         iswhere += " AND bts_readstatus IN(#{inclause})"
                      end
               end


         else
               iswhere += " AND bts_readstatus ='N'"
         end
     end
    

   isselect   = "st_name as sitename,trn_batch_task_assigns.*,btc.id as btcId,st.id as stId,btc_name,bts_multiassign as ms_assignuser"
   jonx       = " LEFT JOIN mst_site_masters st ON(st_compcode = bts_compcode AND st_number = bts_siteno)"
   jonx      += " JOIN mst_batch_task_categories btc ON(btc_compcode = bts_compcode AND btc.id = bts_taskcat)"
   
  assignobj = TrnBatchTaskAssign.select(isselect).joins(jonx).where(iswhere).order("btc_name ASC")
   return assignobj
end

private
def all_category_assigned_intask(siteno)
   posteduserid     = params[:assigneduserto].to_i >0 ? params[:assigneduserto] :  session[:assigneduserto]
   loguserid        = session[:autherizedUserId]
   assigntaskstatus = params[:assigntaskstatus] !=nil && params[:assigntaskstatus] !='' ? params[:assigntaskstatus] : session[:assigntaskstatus]
   processtask      = params[:processtask]
   listclause       = ""
   newclause        = ""
   if assigntaskstatus !=nil && assigntaskstatus !=''
        assigntaskstatus.each do |gtask|          
           listclause += gtask.to_s+","
           newclause  +="'"+gtask.to_s+"',"
         end
       @listItem = listclause
       if newclause != nil && newclause !=''
            newclause = newclause.to_s.chop
         end
   end
   if posteduserid.to_i >0
     iswhere    = "bts_compcode = '#{@compcodes}' AND bts_taskcat >0 AND bts_siteno ='#{siteno}' AND ( bts_assignby ='#{loguserid}' AND FIND_IN_SET('#{posteduserid}',bts_multiassign)>0 )"
   else
     iswhere    = "bts_compcode = '#{@compcodes}' AND bts_taskcat >0 AND bts_siteno ='#{siteno}' AND ( bts_assignby ='#{loguserid}'  OR  FIND_IN_SET('#{loguserid}',bts_multiassign)>0 )"
   end
   
   if newclause !=nil && newclause !=''
       nstrip = newclause.to_s.delete("'");
       if nstrip !=nil && nstrip !='' && nstrip !='all'
          iswhere  += " AND bts_readstatus = #{newclause}"
       end
   else
       if processtask == '' || processtask == nil
         iswhere  += " AND bts_readstatus = 'N'"
       end
      
   end
   if processtask == 'TD'
      iswhere  += " AND DATE(bts_assigndate) = DATE(NOW()) "
    elsif processtask == 'PD'
      iswhere  += " AND bts_readstatus ='N' "
    elsif processtask == 'SD'
      iswhere  += " AND bts_assigndate BETWEEN CURDATE() AND DATE_ADD(CURDATE(),INTERVAL 7 DAY) "
   end
   
   isselect   = "btc.id as btcId,btc_name"
   jonx       = " JOIN mst_batch_task_categories btc ON(btc_compcode = bts_compcode AND btc.id = bts_taskcat)"
   
  assignobj  = TrnBatchTaskAssign.select(isselect).joins(jonx).where(iswhere).group("btc_name")
   return assignobj
end

private
def all_sitewise_task_listing
   posteduserid     = params[:assigneduserto].to_i >0 ? params[:assigneduserto] :  session[:assigneduserto]
   loguserid        = session[:autherizedUserId]
   assigntaskstatus = params[:assigntaskstatus] !=nil && params[:assigntaskstatus] !='' ? params[:assigntaskstatus] : session[:assigntaskstatus]
   processtask      = params[:processtask]
   listclause       = ""
   newclause        = ""
   if assigntaskstatus !=nil && assigntaskstatus !=''
        assigntaskstatus.each do |gtask|
           listclause += gtask.to_s+","
           newclause  += "'"+gtask.to_s+"',"
         end
         @listItem = listclause
         if newclause != nil && newclause !=''
            newclause = newclause.to_s.chop
         end
         session[:assigntaskstatus] = params[:assigntaskstatus]
   end
   @posteduserid = posteduserid   
   if posteduserid.to_i >0
      session[:assigneduserto] = params[:assigneduserto]
      iswhere    = "bts_compcode = '#{@compcodes}' AND st_number >0 AND ( bts_assignby ='#{loguserid}'  AND  FIND_IN_SET('#{posteduserid}',bts_multiassign)>0 )"
   else
      iswhere    = "bts_compcode = '#{@compcodes}' AND st_number >0 AND ( bts_assignby ='#{loguserid}'  OR   FIND_IN_SET('#{loguserid}',bts_multiassign)>0 )"
   end
   
   if newclause !=nil && newclause !=''
       nstrip = newclause.to_s.delete("'");
       if nstrip !=nil && nstrip !='' && nstrip !='all'
          iswhere  += " AND bts_readstatus = #{newclause}"
       end
   else
      if processtask == '' || processtask == nil
         iswhere  += " AND bts_readstatus = 'N'"
       end
   end
   if processtask == 'TD'
       iswhere  += " AND DATE(bts_assigndate) = DATE(NOW()) "
    elsif processtask == 'PD'
       iswhere  += " AND bts_readstatus ='N' "
    elsif processtask == 'SD'
       iswhere  += " AND bts_assigndate BETWEEN CURDATE() AND DATE_ADD(CURDATE(),INTERVAL 7 DAY) "   
    end
   isselect   = "sts.id as btcId,st_name,bts_siteno,GROUP_CONCAT(trn_batch_task_assigns.id) as tasklist"
   jonx       = " JOIN mst_site_masters sts ON(st_compcode = bts_compcode AND st_number = bts_siteno)"
  # jonx      += " JOIN trn_multi_assigns ms ON(bts_compcode = ms_compcode AND ms_projectsite = bts_siteno AND bts_batchtask = ms_batchtask)"
   assignobj  = TrnBatchTaskAssign.select(isselect).joins(jonx).where(iswhere).group("bts_siteno").order("st_name ASC")

  return assignobj
end

private
def get_sitewise_pending_task(siteno,type)
    tcounts = 0
    posteduserid     = params[:assigneduserto].to_i >0 ? params[:assigneduserto] :  session[:assigneduserto]
    loguserid        = session[:autherizedUserId]
    assignbyuser     = loguserid
    assignuser       = loguserid
    processtask      = params[:processtask]

    if posteduserid.to_i >0
      iswhere      = "bts_compcode = '#{@compcodes}' AND bts_siteno = '#{siteno}' AND ( bts_assignby ='#{assignbyuser}' AND  FIND_IN_SET('#{posteduserid}',bts_multiassign)>0  )"
    else
     iswhere      = "bts_compcode = '#{@compcodes}' AND bts_siteno = '#{siteno}' AND ( bts_assignby ='#{assignbyuser}'  OR  FIND_IN_SET('#{assignuser}',bts_multiassign)>0  )"
    end
    if type == 'PND'
       iswhere += " AND bts_readstatus = 'N'"
    end
    if processtask == 'TD'
      iswhere  += " AND DATE(bts_assigndate) = DATE(NOW()) "
    elsif processtask == 'PD'
     iswhere  += " AND bts_readstatus ='N' "
    elsif processtask == 'SD'
     iswhere  += " AND bts_assigndate BETWEEN CURDATE() AND DATE_ADD(CURDATE(),INTERVAL 7 DAY) "    
    end
    isselect   = "COUNT(*) as tcounts"    
    assignobj  = TrnBatchTaskAssign.select(isselect).where(iswhere).first
    if assignobj
    tcounts = assignobj.tcounts
    end
   return tcounts
   
end

private
def get_task_signle_listed(siteno,catid) 
    loguserid        = session[:autherizedUserId]
    assignbyuser     = loguserid
    assignuser       = loguserid
    
    if catid.to_i == 1
      iswhere      = "bts_compcode = '#{@compcodes}' AND bts_siteno = '#{siteno}' AND bts_taskcat ='#{catid}' AND ( bts_assignby ='#{assignbyuser}'  OR  FIND_IN_SET('#{assignuser}',bts_multiassign)>0  )"
    else
      iswhere      = "bts_compcode = '#{@compcodes}' AND bts_siteno = '#{siteno}' AND bts_taskcat ='#{catid}' AND ( bts_assignby ='#{assignbyuser}'  OR  FIND_IN_SET('#{assignuser}',bts_multiassign)>0  )"
    end
    
    isselect   = "GROUP_CONCAT(id) as tasklistid"
    assignobj  = TrnBatchTaskAssign.select(isselect).where(iswhere).first
    return assignobj
end


end


