# To change this template, choose Tools | Templates
# and open the template in the editor.

class LedgersPdf < Prawn::Document
  def initialize(report,loc,shipto,compDetail,cstype,uRl,isProforma,isTakeTax,gprams,opbal,clbal,lastPayment,isrndamt)
    super(:margin_top=>20,:page_size =>"A4")
    @invoice    = report
    @loc        = loc
    @shipto     = shipto
    @compDetail = compDetail
    @cstype     = cstype
    @uRl2       = uRl
    @uRl        = Rails.root.join "public"
    @logoSize   = 0.5
    @isProforma = isProforma
    @isTakeTax  = isTakeTax
    @from_date  = gprams[:from_date].to_s
    @upto_date  = gprams[:upto_date].to_s
    @isSaleType = gprams[:issaletype].to_s
    @from_item  = gprams[:from_item].to_s
    @upto_item  = gprams[:upto_item].to_s
    @show_add   = gprams[:comp_show_add].to_s
    @customer   = shipto ? shipto.cs_customername.to_s : ''
    @cellnumber = '' # shipto ? shipto.cs_mobilenumber.to_s : ''
    @phnumber   = '' # shipto ? shipto.cs_telephonenumbers.to_s : ''
    @emaladd    = '' # shipto ? shipto.cs_emailaddress.to_s : ''
    @opbal      = opbal
    @clbal      = clbal
    @isgodaam   =  (@compDetail.cmp_godam_allowed=='Y' ) ? true : false
    @isrndamt   =  ( isrndamt!='' && isrndamt =='Y' ) ? true : false
    if lastPayment!=nil
      @lastPayment = lastPayment.pr_netamount!='' ? '%.2f' % lastPayment.pr_netamount : ''
      @lastPmtDate = lastPayment.pr_date!='' ? lastPayment.pr_date : ''
    else
     @lastPayment = ''
     @lastPmtDate = ''
    end
    make_sum_of_all
    invoice_items
    line_items
 end

 def invoice_items
    #text "GST : TAV37629121N"
  end
  def terms_and_conditions
       "Terms and Conditions"
  end
  def count_mcell
  @count_cell ||= 0
  @count_cell = @count_cell+1
end
  def line_items

        move_down 2
          pad(-1) {
            if @compDetail.cmp_logos.to_s.length >1
                npath = Rails.root.join "public",'images','logo','thumb'
               if File.exists?("#{npath}/"+@compDetail.cmp_logos.to_s)
                 image open(@uRl+"images/logo/thumb/"+@compDetail.cmp_logos.to_s),:scale => @logoSize,:position => :right,:vposition => :top
               end
              end
          }
          # header
          nfrdats =''
          bounding_box [bounds.left, bounds.top], :width  => bounds.width do
          font "Helvetica"
          if @compDetail.cmp_companyname.to_s!=nil && @compDetail.cmp_companyname.to_s!=''
          text @compDetail.cmp_companyname.to_s.upcase, :align => :left, :size => 10,:vposition => :top
          end
          if @compDetail.cmp_addressline1.to_s!=nil && @compDetail.cmp_addressline1.to_s!=''
          text ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? @compDetail.cmp_addressline1.to_s.capitalize: '' )+((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline2.to_s.capitalize : '')+((@compDetail.cmp_addressline3.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ', ': '' )+@compDetail.cmp_addressline3.to_s.capitalize: ''), :align => :left, :size => 9,:vposition => :top
          end
          if @compDetail.cmp_telephonenumber.to_s!=nil && @compDetail.cmp_telephonenumber.to_s!=''
          text @compDetail.cmp_telephonenumber.to_s+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? ', +91 ': '')+@compDetail.cmp_cell_number.to_s, :align => :left, :size =>9,:vposition => :top
          end
          if @from_date!='' && @from_date!=nil
            frdats  = Date.parse(@from_date.to_s)
            nfrdats = frdats.strftime('%d-%b-%Y')
          end
          if @upto_date!='' && @upto_date!=nil
            
            utdats  = Date.parse(@upto_date.to_s)
            nutdats = utdats.strftime('%d-%b-%Y')
          end
          ltnewdats = ''
          if @lastPmtDate!=nil && @lastPmtDate!=''
            ltdats    = Date.parse(@lastPmtDate.to_s)
            ltnewdats = ltdats.strftime('%d-%b-%Y')
          end

          if @isSaleType!=nil && @isSaleType!='' && @isSaleType=='LGR'
          text "Ledger Register", :align => :center, :size =>12
          end
          if @customer!=nil && @customer!=''
            #text "Customer: "+@customer.to_s, :align => :center, :size =>8
          end
          if @from_date!=nil && @from_date!='' && @upto_date!='' && @upto_date!=nil
            text "From Date : "+nfrdats.to_s+" Upto Date : "+nutdats.to_s, :align => :center, :size =>8
          elsif @from_date!=nil && @from_date!=''
            text "From Date : "+nfrdats.to_s, :align => :center, :size =>8
          elsif @upto_date!='' && @upto_date!=nil
            text "Upto Date : "+nutdats.to_s, :align => :center, :size =>8
          end
         
           move_down 5
           if @lastPayment.to_s!=nil && @lastPayment.to_s!=''
           text "Last Payment Received: "+@lastPayment.to_s+" On Date : "+ltnewdats.to_s, :align => :center, :size =>10
           end
           if @customer.to_s.length >1
           text "Customer Name : "+(@customer.to_s.length >1 ? @customer.to_s : '' ), :align => :left, :size =>9
           end
           if @cellnumber.to_s.length >1
           text "Mobile No. : "+(@cellnumber.to_s.length >1 ? @cellnumber.to_s : '' ), :align => :left, :size =>9
           end
           if @phnumber.to_s.length >1
           text "Phone No. : "+(@phnumber.to_s.length >1 ? @phnumber.to_s : '' ), :align => :left, :size =>9
           end
           if @emaladd.to_s.length >1
           text "Email         :  "+(@emaladd.to_s.length >1 ? @emaladd.to_s : '' ), :align => :left, :size =>9
           end
           move_down 5
           text "Opening Bal. : "+ "%.2f" % @opbal.to_s.delete("-"), :align => :right, :size =>10
           
         

       end

    move_down 10
     lngth =  @invoice.length
     if @invoice.length >0         
              table line_item_rows,:cell_style=>{:inline_format=> TRUE},:width=>525 do
              row(0).column(1..7).align = :center
              row(0).column(1).width    = 30
              row(0).column(2).width    = 20
              row(0).column(4).width    = 60
              row(0).column(6).width    = 30              
              row(1..5000).column(1..4).align = :center
              row(1..5000).column(5..7).align = :right              
              cells.size          = 8
              cells.padding       = 5
              cells.min_width     = 300
              cells.border_width  = 1
              row(0).column(0..15).background_color    = 'D3D3D3'
              row(0).column(0..15).text_color          = '000080'
              self.header =true
            end
        #end
    end
    move_down 4
    text " "
    text " "
     text "Closing Bal. : "+ "%.2f" % @clbal.to_s.delete("-"), :align => :right, :size =>10
    
    
 end

 def line_item_rows
   b1 = [[{:content=> "<b>Total</b>",:inline_format=> TRUE,:colspan=>5,:align=>:left,:size=>:bold },{:content=> "<b>"+currency_formatted(@docdebits).to_s+"</b>",:inline_format=> TRUE,:colspan=>1,:align=>:right,:size=>:bold },{:content=> "<b>"+currency_formatted(@doccredits).to_s+"</b>",:colspan=>1,:align=>:right,:size=>:bold },""]]
   [["Sl.No.","Type","Doc.Date","Doc.No","Remarks","Debit","Credit","Balance"]]+
      @invoice.each.map do |inv|
        [count,(inv.doctype.to_s!=nil ? inv.doctype.to_s : ''),inv.docDate.to_s,(inv.docnumber.to_s!=nil ? inv.docnumber.to_s : ''),(inv.remarks.to_s!=nil ? inv.remarks.to_s : ''),(inv.docdebits.to_s!=nil ? currency_formatted(inv.docdebits).to_s : ''),(inv.doccredits.to_s!=nil ? currency_formatted(inv.doccredits).to_s : ''),(inv.docbalance.to_s != nil ? currency_formatted(inv.docbalance.to_f.to_s.delete("-")) : '' )]
      end+b1

end

def count
  @count ||= 0
  @count = @count+1
end
def make_sum_of_all
    
    @docdebits  = 0
    @doccredits = 0
    @invoice.each do |ts|
        @docdebits    = @docdebits+ts.docdebits.to_f
        @doccredits   = @doccredits+ts.doccredits.to_f        
   end
   
 end
 
   private
   def currency_formatted(amt)
        amts = ''
        if amt!=nil && amt!=''
          amts = "%.2f" % amt.to_f
        end
        return amts
   end
 def number_currency_in_words
   NumbersInWords.in_words(@tnetamt.to_f).split(/ |\_|\-/).map(&:capitalize).join(" ")
 end
def date_formats(dates)
  if dates.to_s!=nil && dates.to_s!=''
    nrdate = Date.parse(dates.to_s)
    ndate  = nrdate.strftime('%d-%b-%Y')
  end
end
end
